from datetime import datetime, timedelta

import pymongo
from discord.ext.tasks import loop

import jarvis
from jarvis.db.types import Warning


@loop(hours=1)
async def unwarn():
    warns = Warning.get_active()
    updates = []
    for warn in warns:
        if (
            warn.created_at + timedelta(hours=warn.duration)
            < datetime.utcnow()
        ):
            updates.append(
                pymongo.UpdateOne(
                    {"_id": warn._id}, {"$set": {"active": False}}
                )
            )
    if updates:
        jarvis.jarvis_db.warns.bulk_write(updates)
